<template>
    <Button v-if="fromCosmosToEth" v-on:click=" (async () => await web3Connector())">
        
        <i v-if="!isKeplrWalletConnected" class="pi pi-circle-on p-col" style="color:red; vertical-align: middle;"/>
        <label v-if="!isKeplrWalletConnected">Keplr Wallet Not Connected</label>

        <i v-if="isKeplrWalletConnected" class="pi pi-circle-on p-col" style="color:green; vertical-align: middle;"/>
        <label v-if="isKeplrWalletConnected">Keplr Wallet Connected</label>

    </Button>

    <Button v-if="!fromCosmosToEth" v-on:click=" (async () => await web3Connector())">
      
      <i v-if="!isMetamaskWalletConnected" class="pi pi-circle-on p-col" style="color:red; vertical-align: middle;"/>
      <label v-if="!isMetamaskWalletConnected">Metamask Wallet Not Connected</label>

      <i v-if="isMetamaskWalletConnected" class="pi pi-circle-on p-col" style="color:green; vertical-align: middle;"/>
      <label v-if="isMetamaskWalletConnected">Metamask Wallet Connected</label>
      
    </Button>
</template>

<script>

import {connectToWeb3} from '../services/web3'

export default {
  name: 'WalletConnectButton',
  computed:{
    fromCosmosToEth(){
      return this.$store.state.fromCosmosToEth
    },
    isMetamaskWalletConnected(){
      return this.$store.state.isMetamaskWalletConnected
    },
    isKeplrWalletConnected(){
      return this.$store.state.isKeplrWalletConnected
    },
    cosmosSendingAddress(){
      return this.$store.state.cosmosSendingAddress
    },
    ethSendingAddress(){
      return this.$store.state.ethSendingAddress
    }
  },
  methods:{
      async web3Connector(){
        const response = await connectToWeb3(window,this.fromCosmosToEth)
        console.log(response)
        console.log(response.wallet)
        
        if(response.wallet == "keplr"){
          if(response.status == 200){
            this.$store.commit('setIsKeplrWalletConnected',true)
            this.$store.commit('setCosmosSendingAddress',response.sendingAddress)
          }
          else{
            this.$store.commit('setIsKeplrWalletConnected',false)
            this.$store.commit('setCosmosSendingAddress',response.sendingAddress)
          }
        }
        else if (response.wallet == "metamask"){
          if(response.status == 200){
            this.$store.commit('setIsMetamaskWalletConnected',true)
            this.$store.commit('setEthSendingAddress',response.sendingAddress)
          }
          else{
            this.$store.commit('setIsMetamaskWalletConnected',false)
            this.$store.commit('setEthSendingAddress',response.sendingAddress)
          }
        }
    }
  }
}
</script>

<style scoped>

</style>